package cml04eventer

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestMetaData_Get(t *testing.T) {
	// Crear una instancia de MetaData
	meta := NewMetaData()

	// Agregar un valor a MetaData
	key := "test-key"
	value := "test-value"
	meta.Set(key, value)

	// Obtener el valor y verificar que sea correcto
	result, err := meta.Get(key)
	assert.NoError(t, err)
	assert.Equal(t, value, result)

	// Intentar obtener un valor inexistente y verificar que se devuelva un error
	_, err = meta.Get("non-existent-key")
	assert.Error(t, err)
}

func TestMetaData_Set(t *testing.T) {
	// Crear una instancia de MetaData
	meta := NewMetaData()

	// Establecer un valor en MetaData
	key := "test-key"
	value := "test-value"
	meta.Set(key, value)

	// Obtener el valor y verificar que sea correcto
	result, err := meta.Get(key)
	assert.NoError(t, err)
	assert.Equal(t, value, result)
}

func TestMetaData_Delete(t *testing.T) {
	// Crear una instancia de MetaData
	meta := NewMetaData()

	// Agregar un valor a MetaData
	key := "test-key"
	value := "test-value"
	meta.Set(key, value)

	// Eliminar el valor y verificar que se haya eliminado correctamente
	meta.Delete(key)

	// Intentar obtener el valor eliminado y verificar que se devuelva un error
	_, err := meta.Get(key)
	assert.Error(t, err)
}
