package cml04eventer

import "errors"

type MetaData map[string]interface{}

func (m MetaData) Get(key string) (interface{}, error) {
	value, ok := m[key]
	if !ok {
		return nil, errors.New("key not found")
	}
	return value, nil
}

func (m MetaData) Set(key string, value interface{}) {
	m[key] = value
}

func (m MetaData) Delete(key string) {
	delete(m, key)
}

func NewMetaData() MetaData {
	return make(map[string]interface{})
}
